package com.eclipsesource.json;

import java.io.IOException;
import java.io.Reader;
























































public final class Json
{
  public static final JsonValue NULL = new JsonLiteral("null");
  



  public static final JsonValue TRUE = new JsonLiteral("true");
  



  public static final JsonValue FALSE = new JsonLiteral("false");
  


  private Json() {}
  


  public static JsonValue value(int paramInt)
  {
    return new JsonNumber(Integer.toString(paramInt, 10));
  }
  






  public static JsonValue value(long paramLong)
  {
    return new JsonNumber(Long.toString(paramLong, 10));
  }
  






  public static JsonValue value(float paramFloat)
  {
    if ((Float.isInfinite(paramFloat)) || (Float.isNaN(paramFloat))) {
      throw new IllegalArgumentException("Infinite and NaN values not permitted in JSON");
    }
    return new JsonNumber(cutOffPointZero(Float.toString(paramFloat)));
  }
  






  public static JsonValue value(double paramDouble)
  {
    if ((Double.isInfinite(paramDouble)) || (Double.isNaN(paramDouble))) {
      throw new IllegalArgumentException("Infinite and NaN values not permitted in JSON");
    }
    return new JsonNumber(cutOffPointZero(Double.toString(paramDouble)));
  }
  






  public static JsonValue value(String paramString)
  {
    return paramString == null ? NULL : new JsonString(paramString);
  }
  






  public static JsonValue value(boolean paramBoolean)
  {
    return paramBoolean ? TRUE : FALSE;
  }
  





  public static JsonValue array()
  {
    return new JsonArray();
  }
  







  public static JsonArray array(int... paramVarArgs)
  {
    if (paramVarArgs == null) {
      throw new NullPointerException("values is null");
    }
    JsonArray localJsonArray = new JsonArray();
    for (int k : paramVarArgs) {
      localJsonArray.add(k);
    }
    return localJsonArray;
  }
  







  public static JsonArray array(long... paramVarArgs)
  {
    if (paramVarArgs == null) {
      throw new NullPointerException("values is null");
    }
    JsonArray localJsonArray = new JsonArray();
    for (long l : paramVarArgs) {
      localJsonArray.add(l);
    }
    return localJsonArray;
  }
  







  public static JsonArray array(float... paramVarArgs)
  {
    if (paramVarArgs == null) {
      throw new NullPointerException("values is null");
    }
    JsonArray localJsonArray = new JsonArray();
    for (float f : paramVarArgs) {
      localJsonArray.add(f);
    }
    return localJsonArray;
  }
  







  public static JsonArray array(double... paramVarArgs)
  {
    if (paramVarArgs == null) {
      throw new NullPointerException("values is null");
    }
    JsonArray localJsonArray = new JsonArray();
    for (double d : paramVarArgs) {
      localJsonArray.add(d);
    }
    return localJsonArray;
  }
  







  public static JsonArray array(boolean... paramVarArgs)
  {
    if (paramVarArgs == null) {
      throw new NullPointerException("values is null");
    }
    JsonArray localJsonArray = new JsonArray();
    for (int k : paramVarArgs) {
      localJsonArray.add(k);
    }
    return localJsonArray;
  }
  






  public static JsonArray array(String... paramVarArgs)
  {
    if (paramVarArgs == null) {
      throw new NullPointerException("values is null");
    }
    JsonArray localJsonArray = new JsonArray();
    for (String str : paramVarArgs) {
      localJsonArray.add(str);
    }
    return localJsonArray;
  }
  





  public static JsonObject object()
  {
    return new JsonObject();
  }
  









  public static JsonValue parse(String paramString)
  {
    if (paramString == null) {
      throw new NullPointerException("string is null");
    }
    try {
      return new JsonParser(paramString).parse();
    }
    catch (IOException localIOException) {
      throw new RuntimeException(localIOException);
    }
  }
  
















  public static JsonValue parse(Reader paramReader)
  {
    if (paramReader == null) {
      throw new NullPointerException("reader is null");
    }
    return new JsonParser(paramReader).parse();
  }
  
  private static String cutOffPointZero(String paramString) {
    if (paramString.endsWith(".0")) {
      return paramString.substring(0, paramString.length() - 2);
    }
    return paramString;
  }
}
