package com.eclipsesource.json;

import java.io.Reader;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;























































public class JsonArray
  extends JsonValue
  implements Iterable
{
  private final List values;
  
  public JsonArray()
  {
    values = new ArrayList();
  }
  





  public JsonArray(JsonArray paramJsonArray)
  {
    this(paramJsonArray, false);
  }
  
  private JsonArray(JsonArray paramJsonArray, boolean paramBoolean) {
    if (paramJsonArray == null) {
      throw new NullPointerException("array is null");
    }
    if (paramBoolean) {
      values = Collections.unmodifiableList(values);
    } else {
      values = new ArrayList(values);
    }
  }
  


















  @Deprecated
  public static JsonArray readFrom(Reader paramReader)
  {
    return JsonValue.readFrom(paramReader).asArray();
  }
  











  @Deprecated
  public static JsonArray readFrom(String paramString)
  {
    return JsonValue.readFrom(paramString).asArray();
  }
  











  public static JsonArray unmodifiableArray(JsonArray paramJsonArray)
  {
    return new JsonArray(paramJsonArray, true);
  }
  







  public JsonArray add(int paramInt)
  {
    values.add(Json.value(paramInt));
    return this;
  }
  







  public JsonArray add(long paramLong)
  {
    values.add(Json.value(paramLong));
    return this;
  }
  







  public JsonArray add(float paramFloat)
  {
    values.add(Json.value(paramFloat));
    return this;
  }
  







  public JsonArray add(double paramDouble)
  {
    values.add(Json.value(paramDouble));
    return this;
  }
  







  public JsonArray add(boolean paramBoolean)
  {
    values.add(Json.value(paramBoolean));
    return this;
  }
  






  public JsonArray add(String paramString)
  {
    values.add(Json.value(paramString));
    return this;
  }
  






  public JsonArray add(JsonValue paramJsonValue)
  {
    if (paramJsonValue == null) {
      throw new NullPointerException("value is null");
    }
    values.add(paramJsonValue);
    return this;
  }
  












  public JsonArray set(int paramInt1, int paramInt2)
  {
    values.set(paramInt1, Json.value(paramInt2));
    return this;
  }
  












  public JsonArray set(int paramInt, long paramLong)
  {
    values.set(paramInt, Json.value(paramLong));
    return this;
  }
  












  public JsonArray set(int paramInt, float paramFloat)
  {
    values.set(paramInt, Json.value(paramFloat));
    return this;
  }
  












  public JsonArray set(int paramInt, double paramDouble)
  {
    values.set(paramInt, Json.value(paramDouble));
    return this;
  }
  












  public JsonArray set(int paramInt, boolean paramBoolean)
  {
    values.set(paramInt, Json.value(paramBoolean));
    return this;
  }
  












  public JsonArray set(int paramInt, String paramString)
  {
    values.set(paramInt, Json.value(paramString));
    return this;
  }
  











  public JsonArray set(int paramInt, JsonValue paramJsonValue)
  {
    if (paramJsonValue == null) {
      throw new NullPointerException("value is null");
    }
    values.set(paramInt, paramJsonValue);
    return this;
  }
  









  public JsonArray remove(int paramInt)
  {
    values.remove(paramInt);
    return this;
  }
  




  public int size()
  {
    return values.size();
  }
  




  public boolean isEmpty()
  {
    return values.isEmpty();
  }
  









  public JsonValue get(int paramInt)
  {
    return (JsonValue)values.get(paramInt);
  }
  






  public List values()
  {
    return Collections.unmodifiableList(values);
  }
  





  public Iterator iterator()
  {
    Iterator localIterator = values.iterator();
    return new JsonArray.1(this, localIterator);
  }
  













  void write(JsonWriter paramJsonWriter)
  {
    paramJsonWriter.writeArrayOpen();
    Iterator localIterator = iterator();
    int i = 1;
    while (localIterator.hasNext()) {
      if (i == 0) {
        paramJsonWriter.writeArraySeparator();
      }
      ((JsonValue)localIterator.next()).write(paramJsonWriter);
      i = 0;
    }
    paramJsonWriter.writeArrayClose();
  }
  
  public boolean isArray()
  {
    return true;
  }
  
  public JsonArray asArray()
  {
    return this;
  }
  
  public int hashCode()
  {
    return values.hashCode();
  }
  
  public boolean equals(Object paramObject)
  {
    if (this == paramObject) {
      return true;
    }
    if (paramObject == null) {
      return false;
    }
    if (getClass() != paramObject.getClass()) {
      return false;
    }
    JsonArray localJsonArray = (JsonArray)paramObject;
    return values.equals(values);
  }
}
