package com.eclipsesource.json;













class JsonNumber
  extends JsonValue
{
  private final String string;
  











  JsonNumber(String paramString)
  {
    if (paramString == null) {
      throw new NullPointerException("string is null");
    }
    string = paramString;
  }
  
  public String toString()
  {
    return string;
  }
  
  void write(JsonWriter paramJsonWriter)
  {
    paramJsonWriter.writeNumber(string);
  }
  
  public boolean isNumber()
  {
    return true;
  }
  
  public int asInt()
  {
    return Integer.parseInt(string, 10);
  }
  
  public long asLong()
  {
    return Long.parseLong(string, 10);
  }
  
  public float asFloat()
  {
    return Float.parseFloat(string);
  }
  
  public double asDouble()
  {
    return Double.parseDouble(string);
  }
  
  public int hashCode()
  {
    return string.hashCode();
  }
  
  public boolean equals(Object paramObject)
  {
    if (this == paramObject) {
      return true;
    }
    if (paramObject == null) {
      return false;
    }
    if (getClass() != paramObject.getClass()) {
      return false;
    }
    JsonNumber localJsonNumber = (JsonNumber)paramObject;
    return string.equals(string);
  }
}
