package com.eclipsesource.json;

import java.io.Writer;





























class WritingBuffer
  extends Writer
{
  private final Writer writer;
  private final char[] buffer;
  private int fill = 0;
  
  WritingBuffer(Writer paramWriter) {
    this(paramWriter, 16);
  }
  
  WritingBuffer(Writer paramWriter, int paramInt) {
    writer = paramWriter;
    buffer = new char[paramInt];
  }
  
  public void write(int paramInt)
  {
    if (fill > buffer.length - 1) {
      flush();
    }
    buffer[(fill++)] = ((char)paramInt);
  }
  
  public void write(char[] paramArrayOfChar, int paramInt1, int paramInt2)
  {
    if (fill > buffer.length - paramInt2) {
      flush();
      if (paramInt2 > buffer.length) {
        writer.write(paramArrayOfChar, paramInt1, paramInt2);
        return;
      }
    }
    System.arraycopy(paramArrayOfChar, paramInt1, buffer, fill, paramInt2);
    fill += paramInt2;
  }
  
  public void write(String paramString, int paramInt1, int paramInt2)
  {
    if (fill > buffer.length - paramInt2) {
      flush();
      if (paramInt2 > buffer.length) {
        writer.write(paramString, paramInt1, paramInt2);
        return;
      }
    }
    paramString.getChars(paramInt1, paramInt1 + paramInt2, buffer, fill);
    fill += paramInt2;
  }
  



  public void flush()
  {
    writer.write(buffer, 0, fill);
    fill = 0;
  }
  
  public void close() {}
}
