package com.mojang.authlib;

import com.mojang.authlib.properties.PropertyMap;
import java.util.Map;

public abstract interface UserAuthentication
{
  public abstract boolean canLogIn();
  
  public abstract void logIn();
  
  public abstract void logOut();
  
  public abstract boolean isLoggedIn();
  
  public abstract boolean canPlayOnline();
  
  public abstract GameProfile[] getAvailableProfiles();
  
  public abstract GameProfile getSelectedProfile();
  
  public abstract void selectGameProfile(GameProfile paramGameProfile);
  
  public abstract void loadFromStorage(Map paramMap);
  
  public abstract Map saveForStorage();
  
  public abstract void setUsername(String paramString);
  
  public abstract void setPassword(String paramString);
  
  public abstract String getAuthenticatedToken();
  
  public abstract String getUserID();
  
  public abstract PropertyMap getUserProperties();
  
  public abstract UserType getUserType();
}
