package com.mojang.util;

import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.util.UUID;

public class UUIDTypeAdapter extends com.google.gson.TypeAdapter
{
  public UUIDTypeAdapter() {}
  
  public void write(JsonWriter paramJsonWriter, UUID paramUUID)
  {
    paramJsonWriter.value(fromUUID(paramUUID));
  }
  
  public UUID read(JsonReader paramJsonReader)
  {
    return fromString(paramJsonReader.nextString());
  }
  
  public static String fromUUID(UUID paramUUID) {
    return paramUUID.toString().replace("-", "");
  }
  
  public static UUID fromString(String paramString) {
    return UUID.fromString(paramString.replaceFirst("(\\w{8})(\\w{4})(\\w{4})(\\w{4})(\\w{12})", "$1-$2-$3-$4-$5"));
  }
}
